#!/usr/bin/perl

open(FILE, $ARGV[0]) or die "Cannot open $ARGV[0]";

my @nameArray;
my @valueArray;
my %taghash;
my $set;
my $setname;
my $title = "";

my $xml;

while(<FILE>) {
	chomp;
	if ($_ eq "") {
		if ($title eq "") {
			@valueArray = ();
			@nameArray = ();
		} else {
			my $cardName = $title;
			$cardName =~ s/"/&quot;/g;
			$xml .= "\t<card name=\"" . $cardName . "\">\n";
			$imgName = lc($title);
			$imgName =~ s/[^a-z0-9]/_/g;
			$xml .= "\t\t<img src=\"shadowfist/" . $set . "/" . $imgName . ".png\"/>\n";

			while (scalar(@nameArray) > 0) {
				my $tag = lc(shift(@nameArray));
				$tag =~ s/ /_/g;
				my $value = shift(@valueArray);
				$value =~ s/&/&amp;/g;
				$value =~ s/"/&quot;/g;
				$value =~ s/>/&gt;/g;
				$value =~ s/</&lt;/g;
				$xml .= "\t\t<attribute name=\"$tag\" value=\"$value\"/>\n";
				$taghash{$tag}++;
			}
			$xml .= "\t</card>\n";
		}
	} else {
		if (/^ +/) {
			$valueArray[$#valueArray] .= $';
		} else {
			($name, $value) = split(/: /, $_, 2);
			$value =~ s/^ +//;
			if (lc($name) eq "title") {
				$title = $value;
			} elsif ($name ne "") {
				$nameArray[++$#nameArray] = $name;
				$valueArray[++$#valueArray] = $value;
				if (lc($name) eq "set") {
					$setname = $value;
					$set = lc($value);
					$set =~ s/[^a-z0-9]/_/g;
				}
			}
		}
	}
}

print "<?xml version='1.0' encoding='ISO-8859-1'?>\n\n";
print "<!DOCTYPE cardset SYSTEM \"ccg_cardset.dtd\">\n\n";
print "<cardset name=\"$setname\">\n";
print $xml;
print "</cardset>";

foreach (sort keys %taghash) {
	print STDERR lc($_) . "\n";
}
